export declare type SortingVector = (number | string)[];
declare type CompareEquals<T> = (a: T, b: T) => number;
declare type GetVector<T> = (t: T) => SortingVector;
export declare function bucketSort<T>(array: T[], getVector?: (t: T) => SortingVector, compareEquals?: CompareEquals<T>): T[];
export declare function stringSort<T>(array: T[], getString?: (t: T) => string): T[];
export declare function stringToVector(string: string): number[];
export declare function compareFull<T>(d1: T, d2: T, getVector: GetVector<T>, compareEquals?: CompareEquals<T>): number;
export declare function compare(vector1: SortingVector, vector2: SortingVector): number;
export declare function bucketSortHelper<T>(array: T[], getVector: GetVector<T>, sort_range_lower_index_incl: number, sort_range_upper_index_excl: number, vector_index: number, isStringElt: boolean): {
    sorted_array: T[];
    bucket_ranges: {
        lower_index_incl: number;
        upper_index_excl: number;
    }[];
};
export {};
