import { ComputedShapeParams } from './oncoprintshape';
import { RGBAColor } from './oncoprintruleset';
declare const _default: {
    text: (content: string, x?: number, y?: number, size?: number, family?: string, weight?: string, alignment_baseline?: string, fill?: string, text_decoration?: string) => SVGTextElement;
    group: (x: number | undefined, y: number | undefined) => SVGGElement;
    svg: (width: number | undefined, height: number | undefined) => SVGSVGElement;
    wrapText: (in_dom_text_svg_elt: SVGTextElement, width: number) => void;
    fromShape: (oncoprint_shape_computed_params: ComputedShapeParams, offset_x: number, offset_y: number) => SVGElement;
    polygon: (points: [number, number][], fill: RGBAColor) => SVGPolygonElement;
    rect: (x: number, y: number, width: number, height: number, fillSpecification: {
        type: 'rgba';
        value: RGBAColor;
    } | {
        type: 'gradientId';
        value: string;
    }) => SVGRectElement;
    bgrect: (width: number, height: number, fill: RGBAColor) => SVGRectElement;
    path: (points: [number, number][], stroke: RGBAColor, fill: RGBAColor, linearGradient: SVGGradientElement) => SVGPathElement;
    stop: (offset: number, color: RGBAColor) => SVGStopElement;
    linearGradient: () => SVGLinearGradientElement;
    defs: () => SVGDefsElement;
    gradient: (colorFn: (val: number) => RGBAColor) => SVGLinearGradientElement;
};
export default _default;
